(function() {
  var createRowData = function(tag, obj) {
    var cols = [];
    for (var e in obj) {
      cols.push(Util.htmlEscape(obj[e]));
    }
    return '<' + tag + '>' + cols.join('</' + tag + '><' + tag + '>') + '</' + tag + '>';
  };
  var clickRoster = function(query) {
    var xtr = Util.createXtr(function() {
      var recs = JSON.parse(xtr.responseText);
      if (recs instanceof Array) {
        var rows = [];
        for (var i = 0; i < recs.length; i++) {
          rows.push(createRowData('td', recs[i]));
        }
        Dialog.show('<table>'
          + '<tr>' + rows.join('</tr><tr>') + '</tr>'
          + '</table>',
          {
          }
        );
      } else {
        document.href = 'index.html';
      }
    });
    xtr.open('GET', 'entries.aspx?' + query, true);
    xtr.send(null);
  };
  document.getElementById('update_rosters').addEventListener('click', function() {
    var xtr = Util.createXtr(function() {
      var eventId = function(id, val) {
        return id + ':' + val;
      }
      var recs = JSON.parse(xtr.responseText);
      var rows = [];
      for (var i = 0; i < recs.length; i++) {
        var row = '<td>' + Util.htmlEscape(recs[i].subject) + '</td><td>';
        var option = null;
        var note;
        if (recs[i].maxunit == 0) {
          var sel0 = ((recs[i].user_unit == 0) ? ' selected' : '');
          var sel1 = ((recs[i].user_unit == 1) ? ' selected' : '');
          option = '<option value="' + eventId(recs[i].id, 0) 
              + '"' + sel0 + '>不参加</option><option value="' + eventId(recs[i].id, 1) 
              + '"' + sel1 + '>参加</option>';
          note = '参加費用:' + recs[i].amount_per_unit + '円, 場所:' 
              + Util.htmlEscape(recs[i].location);
          
        } else {
          option = '<option value="' + eventId(recs[i].id, 0) + '"' +
            ((recs[i].user_unit == 0) ? ' selected' : '') +
            '>―</option>';
          for (var j = 1; j <= recs[i].maxunit; j++) {
            option += '<option value="' + eventId(recs[i].id, j) + '"' +
                   ((j == recs[i].user_unit) ? ' selected' : '') + '>' + j + '口</option>';
          }
          note = '1口:' + recs[i].amount_per_unit + '円';
        }
        if (recs[i].creator || recs[i].owner) {
          note += '<input type="button" value="一覧表示"><input type="hidden" value="' + 
              (recs[i].creator ? 'creator=' : 'owner=') + recs[i].id + '">';
        }
        row += Util.htmlEscape(recs[i].expire_date) + '</td><td>' + 
               Util.htmlEscape(recs[i].creator_name) + '</td><td>' + 
               '<select>' + option + '</select></td><td>' + 
               note + '</td>';
        rows[i] = row;
      }
      if (rows.length > 0) {
        document.getElementById('rosters').innerHTML = '<table>'
          + '<tr><th>趣旨</th><th>掲示期限</th><th>幹事</th><th>参加/口数</th><th>備考</th></tr>'
          + '<tr>' + rows.join('</tr><tr>') + '</tr>'
          + '</table>';
      } else {
        document.getElementById('rosters').innerHTML = '';
      }
    });
    xtr.open('GET', 'rosters.aspx', true);
    xtr.send(null);
  });
  document.getElementById('rosters').addEventListener('change', function(e) {
    var r = e.target.value.match(/([^:]+):(.+)/);
    if (r) {
      var xtr = Util.createXtr(function() {
      });
      Util.postData(xtr, 'rosters.aspx', 'id=' + r[1] + '&unit=' + r[2]);
    }
    e.preventDefault();
  });
  document.getElementById('rosters').addEventListener('click', function(e) {
    if (e.target.value == '一覧表示') {
      clickRoster(e.target.nextElementSibling.value);
    }
    e.preventDefault();
  });
})();
